import { useContext, useMemo } from 'react';
import { getClient } from 'resolve-client';
import { ResolveContext } from './context';

var useClient = function useClient() {
  var context = useContext(ResolveContext);

  if (!context) {
    throw Error('You cannot use reSolve hooks outside Resolve context');
  }

  return useMemo(function () {
    return getClient(context);
  }, [context]);
};

export { useClient };
//# sourceMappingURL=use-client.js.map