import { useCallback } from 'react';
import { useClient } from './use-client';
import { firstOfType, isCallback, isDependencies, isOptions } from './generic';

function useCommandBuilder(builder, options, callback, dependencies) {
  var _firstOfType;

  var client = useClient();
  var actualOptions = firstOfType(isOptions, options);
  var actualCallback = firstOfType(isCallback, options, callback);
  var actualDependencies = (_firstOfType = firstOfType(isDependencies, options, callback, dependencies)) != null ? _firstOfType : [builder, actualOptions, actualCallback].filter(function (i) {
    return i;
  });
  return useCallback(function (data) {
    return client.command(builder(data), actualOptions, actualCallback);
  }, [client].concat(actualDependencies));
}

export { useCommandBuilder };
//# sourceMappingURL=use-command-builder.js.map