import { useCallback } from 'react';
import { firstOfType, isCallback, isDependencies, isOptions } from './generic';
import { useClient } from './use-client';

function useQuery(query, options, callback, dependencies) {
  var _firstOfType;

  var client = useClient();
  var actualOptions = firstOfType(isOptions, options);
  var actualCallback = firstOfType(isCallback, options, callback);
  var actualDependencies = (_firstOfType = firstOfType(isDependencies, options, callback, dependencies)) != null ? _firstOfType : [query, actualOptions, actualCallback].filter(function (i) {
    return i;
  });
  return useCallback(function () {
    return client.query(query, actualOptions, actualCallback);
  }, [client].concat(actualDependencies));
}

export { useQuery };
//# sourceMappingURL=use-query.js.map